;;;======================================================
;;;     Lunochod V 1.0.1
;;;     EXECUTOR Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;   .
;;;======================================================

(defmodule EXECUTOR (import MAIN deftemplate ?ALL) (import MAIN deffunction ?ALL) (import MAIN defglobal ?ALL) (import SOLVER deftemplate ?ALL))

(defrule EXECUTOR::Action-Forward
 ?c <- (cycle ?current-cycle)
 ?f <- (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name forward) (param ?p))
 (agent-image (agent-name ?agent-name) (sym ?sym) (color ?color))
 ?t <- (agent-position (agent-name ?agent-name) (posx ?srcX) (posy ?srcY))
 (agent-direction (agent-name ?agent-name) (direction ?direction))
  =>
 (retract ?t)
 ;(tui_status-print "EXECUTOR::Action=Forward.Step()." 0)
 (if (eq ?direction right)          ; .
  then
   (agent-goto ?sym ?srcX ?srcY (+ ?srcX 1) ?srcY ?color ?*backgroundSymBackColor*)
   (assert (agent-position-next (agent-name ?agent-name) (posx (+ ?srcX 1)) (posy ?srcY)))
  else
   (if (eq ?direction up)           ; .
    then
     (agent-goto ?sym ?srcX ?srcY ?srcX (- ?srcY 1) ?color ?*backgroundSymBackColor*)
     (assert (agent-position-next (agent-name ?agent-name) (posx ?srcX) (posy (- ?srcY 1))))
    else
     (if (eq ?direction down)       ; .
      then
       (agent-goto ?sym ?srcX ?srcY ?srcX (+ ?srcY 1) ?color ?*backgroundSymBackColor*)
       (assert (agent-position-next (agent-name ?agent-name) (posx ?srcX) (posy (+ ?srcY 1))))
      else                          ; .
       (agent-goto ?sym ?srcX ?srcY (- ?srcX 1) ?srcY ?color ?*backgroundSymBackColor*)
       (assert (agent-position-next (agent-name ?agent-name) (posx (- ?srcX 1)) (posy ?srcY)))
      )
   )
 )
 (assert (agent-answer (agent-name ?agent-name) (mission-name ?mission-name) (action-name forward) (status OK)))            ;   SOLVER
)

(defrule EXECUTOR::Action-Left
 ?c <- (cycle ?current-cycle)
 ?f <- (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name left) (param ?p))
 ?t <- (agent-direction (agent-name ?agent-name) (direction ?direction))
 ?r <- (agent-image (agent-name ?agent-name) (sym ?sym) (color ?color))
  =>
 (retract ?t)
 (retract ?r)
 ;(tui_status-print "EXECUTOR::Action=Left.Step()." 0)
 (if(= ?p 90)
  then
   (if (eq ?direction right)         ;  .
    then
     (assert (agent-direction-next (agent-name ?agent-name) (direction up)))
     (assert (agent-image-next (agent-name ?agent-name) (sym 24) (color ?color)))
    else
     (if (eq ?direction up)           ;  .
      then
       (assert (agent-direction-next (agent-name ?agent-name) (direction left)))
       (assert (agent-image-next (agent-name ?agent-name) (sym 27) (color ?color)))
      else
       (if (eq ?direction down)        ;  .
        then
         (assert (agent-direction-next (agent-name ?agent-name) (direction right)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 26) (color ?color)))
        else                             ;  .
         (assert (agent-direction-next (agent-name ?agent-name) (direction down)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 25) (color ?color)))
       )
     )
   )
  else
   (if (eq ?direction right)         ;  .
    then
     (assert (agent-direction-next (agent-name ?agent-name) (direction left)))
     (assert (agent-image-next (agent-name ?agent-name) (sym 27) (color ?color)))
    else
     (if (eq ?direction up)           ;  .
      then
       (assert (agent-direction-next (agent-name ?agent-name) (direction down)))
       (assert (agent-image-next (agent-name ?agent-name) (sym 25) (color ?color)))
      else
       (if (eq ?direction down)        ;  .
        then
         (assert (agent-direction-next (agent-name ?agent-name) (direction up)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 24) (color ?color)))
        else                             ;  .
         (assert (agent-direction-next (agent-name ?agent-name) (direction right)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 26) (color ?color)))
       )
     )
   )
 )
 (assert (agent-answer (agent-name ?agent-name) (mission-name ?mission-name) (action-name left) (status OK)))               ;   SOLVER
)

(defrule EXECUTOR::Action-Right
 ?c <- (cycle ?current-cycle)
 ?f <- (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name right) (param ?p))
 ?t <- (agent-direction (agent-name ?agent-name) (direction ?direction))
 ?r <- (agent-image (agent-name ?agent-name) (sym ?sym) (color ?color))
  =>
 (retract ?t)
 (retract ?r)
 ;(tui_status-print "EXECUTOR::Action=Right.Step()." 0)
 (if(= ?p 90)
  then
   (if (eq ?direction right)         ;  .
    then
     (assert (agent-direction-next (agent-name ?agent-name) (direction down)))
     (assert (agent-image-next (agent-name ?agent-name) (sym 25) (color ?color)))
    else
     (if (eq ?direction up)           ;  .
      then
       (assert (agent-direction-next (agent-name ?agent-name) (direction right)))
       (assert (agent-image-next (agent-name ?agent-name) (sym 26) (color ?color)))
      else
       (if (eq ?direction down)        ;  .
        then
         (assert (agent-direction-next (agent-name ?agent-name) (direction left)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 27) (color ?color)))
        else                             ;  .
         (assert (agent-direction-next (agent-name ?agent-name) (direction up)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 24) (color ?color)))
       )
     )
   )
  else
   (if (eq ?direction right)         ;  .
    then
     (assert (agent-direction-next (agent-name ?agent-name) (direction left)))
     (assert (agent-image-next (agent-name ?agent-name) (sym 27) (color ?color)))
    else
     (if (eq ?direction up)           ;  .
      then
       (assert (agent-direction-next (agent-name ?agent-name) (direction down)))
       (assert (agent-image-next (agent-name ?agent-name) (sym 25) (color ?color)))
      else
       (if (eq ?direction down)        ;  .
        then
         (assert (agent-direction-next (agent-name ?agent-name) (direction up)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 24) (color ?color)))
        else                             ;  .
         (assert (agent-direction-next (agent-name ?agent-name) (direction right)))
         (assert (agent-image-next (agent-name ?agent-name) (sym 26) (color ?color)))
       )
     )
   )
 )
 (assert (agent-answer (agent-name ?agent-name) (mission-name ?mission-name) (action-name right) (status OK)))              ;   SOLVER
)
