;;;======================================================
;;;     Lunochod V 1.0.1
;;;     MISSION Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;   .
;;;======================================================

(defmodule MISSION (export deftemplate ?ALL) (import MAIN deftemplate ?ALL) (import MAIN deffunction ?ALL) (import SIMULATOR deftemplate ?ALL) (import MAIN defglobal ?ALL))

;     .
(deffunction agent-to-index (?agent-name)
 (if(eq ?agent-name lunochod1)
  then 
   (bind ?res 0)
  else
   (bind ?res 1)
 )
)

(defrule MISSION::Mission1-Forward1             ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase forward1))
  =>
 (retract ?f)
 (tui_status-print (str-cat "MISSION::Mission1.Command.Forward1(5). Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 (assert (mission-command (agent-name ?agent-name) (mission-name mission1) (command-name forward) (param 5)))    ;   SOLVER
 (assert (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase right1)))
)

(defrule MISSION::Mission1-Right1               ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase right1))
 ?n <- (mission-answer (agent-name ?agent-name) (mission-name mission1) (command-name forward) ( status OK))
  =>
 (retract ?f)
 (retract ?n)
 (tui_status-print (str-cat "MISSION::Mission1.Command.Right1(90). Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 (assert (mission-command (agent-name ?agent-name) (mission-name mission1) (command-name right) (param 90)))      ;   SOLVER
 (assert (mission-phase (agent-name ?agent-name) (mission-name mission1)(phase forward2)))
)

(defrule MISSION::Mission1-Forward2               ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase forward2))
 ?n <- (mission-answer (agent-name ?agent-name) (mission-name mission1) (command-name right) ( status OK))
  =>
 (retract ?f)
 (retract ?n)
 (tui_status-print (str-cat "MISSION::Mission1.Command.Forward2(3). Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 (assert (mission-command (agent-name ?agent-name) (mission-name mission1) (command-name forward) (param 3)))      ;   SOLVER
 (assert (mission-phase (agent-name ?agent-name) (mission-name mission1)(phase left1)))
)

(defrule MISSION::Mission1-Left1                ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase left1))
 ?n <- (mission-answer (agent-name ?agent-name) (mission-name mission1) (command-name forward) (status OK))
  =>
 (retract ?f)
 (retract ?n)
 (tui_status-print (str-cat "MISSION::Mission1.Command.Left1(8). Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 (assert (mission-command (agent-name ?agent-name) (mission-name mission1) (command-name left) (param 90)))       ;   SOLVER
 (assert (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase forward2)))
)

(defrule MISSION::Mission1-Forward3               ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase forward2))
 ?n <- (mission-answer (agent-name ?agent-name) (mission-name mission1) (command-name left) ( status OK))
  =>
 (retract ?f)
 (retract ?n)
 (tui_status-print (str-cat "MISSION::Mission1.Command.Forward3(8). Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 (assert (mission-command (agent-name ?agent-name) (mission-name mission1) (command-name forward) (param 8)))      ;   SOLVER
 (assert (mission-phase (agent-name ?agent-name) (mission-name mission1)(phase end1)))
)

(defrule MISSION::Mission1-End1                 ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name mission1) (phase end1))
 ?n <- (mission-answer (agent-name ?agent-name) (mission-name mission1) (command-name forward) (status OK))
  =>
 (retract ?f)
 (retract ?n)
 (tui_status-print (str-cat "MISSION::Mission1.Command.End(). Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 
; (tui-color-set ?*statuslineForeColor* ?*statuslineBackColor*)
; (tui-cursor-set 1)
; (sys-object-free ?*gamefieldref*)
; (tui_status-print "" 3)
; (halt)
)

(defrule MISSION::Mission1-Error-End1                 ;    1
 ?c <- (cycle ?current-cycle)
 ?f <- (mission-phase (agent-name ?agent-name) (mission-name ?mission-name))
 ?n <- (mission-answer (agent-name ?agent-name) (mission-name ?mission-name) (command-name ?command-name) (status error))
  =>
 (retract ?f)
 (retract ?n)
 (tui_status-print (str-cat "MISSION::Error:" ?mission-name ". Command:" ?command-name ". Agent:" ?agent-name ". ") (agent-to-index ?agent-name))
 
 ;(tui-color-set ?*statuslineForeColor* ?*statuslineBackColor*)
 ;(tui-cursor-set 1)
 ;(sys-object-free ?*gamefieldref*)
 ;(tui_status-print "" 3)
 ;(halt)
)