;;;======================================================
;;;     Lunochod V 1.0.1
;;;     EXECUTOR Module
;;;     For ECLIPS Version 6.3
;;;     2016.12.02 Victor Kazarinov
;;;======================================================
;;;   .
;;;======================================================

(defmodule SOLVER (export deftemplate ?ALL) (import MAIN deftemplate ?ALL) (import MAIN deffunction ?ALL) (import MAIN defglobal ?ALL) (import SENSOR deftemplate ?ALL))

(defrule SOLVER::Motion-Start
 ?c <- (cycle ?current-cycle)
 ?f <- (agent-sensor (agent-name ?agent-name) (sensor-name barrier) (param absent))
 ?n <- (mission-command (agent-name ?agent-name) (mission-name ?mission-name) (command-name ?command-name) (param ?p))
  =>
 (retract ?f)
 (retract ?n)
 ;(tui_status-print (str-cat "SOLVER::" ?command-name ".Start().") 0)
 (assert (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name ?command-name) (param ?p)))         ;   EXECUTOR
)

(defrule SOLVER::Motion-Cycle
 ?c <- (cycle ?current-cycle)
 ?f <- (agent-sensor (agent-name ?agent-name) (sensor-name barrier) (param absent))
 ?r <- (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name ?action-name) (param ?p))
 ?t <- (agent-answer (agent-name ?agent-name) (mission-name ?mission-name) (action-name ?action-name) (status OK))
  =>
 (retract ?f)
 (retract ?r)
 (retract ?t)
 (if (and (> ?p 1) (eq ?action-name forward))
   then
    ;(tui_status-print (str-cat "SOLVER::" ?action-name ".Continue().") 0)
    (assert (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name ?action-name) (param (- ?p 1))))       ;   EXECUTOR
   else
    ;(tui_status-print (str-cat "SOLVER::" ?action-name ".End().") 0)
    (assert (mission-answer (agent-name ?agent-name) (mission-name ?mission-name) (command-name ?action-name) (status OK)))             ;   MISSION
  )
)

(defrule SOLVER::Barrier-Present
 ?c <- (cycle ?current-cycle)
 ?f <- (agent-sensor (agent-name ?agent-name) (sensor-name barrier) (param present))
 ?r <- (agent-action (agent-name ?agent-name) (mission-name ?mission-name) (action-name ?action-name) (param ?p))
 ?t <- (agent-answer (agent-name ?agent-name) (mission-name ?mission-name) (action-name ?action-name) (status OK))
  =>
 (retract ?f)
 (retract ?r)
 (retract ?t)
 (assert (mission-answer (agent-name ?agent-name) (mission-name ?mission-name) (command-name ?action-name) (status error)))         ;   EXECUTOR
)
 